package jp.co.cybec.laxide.editParts.extension;

import java.beans.PropertyChangeEvent;

import jp.co.cybec.laxide.editParts.EditPartWithListener;
import jp.co.cybec.laxide.editParts.LetsAjaxCellEditorLocator;
import jp.co.cybec.laxide.editParts.LetsAjaxDirectEditManager;
import jp.co.cybec.laxide.editpolicies.LetsAjaxComponentEditPolicy;
import jp.co.cybec.laxide.editpolicies.LetsAjaxDirectEditPolicy;
import jp.co.cybec.laxide.model.extension.YuiBasicAnimateModel;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.CompoundBorder;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.draw2d.MarginBorder;
import org.eclipse.draw2d.ToolbarLayout;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.gef.Request;
import org.eclipse.gef.RequestConstants;
import org.eclipse.jface.viewers.TextCellEditor;

/**
 * YahooUIライブラリのアニメーションJavaScriptを生成するクラス ファイル名：YuiBasicAnimateJSEditPart.java
 * 
 * @author nakamura 作成時刻：14:08:02
 * 
 */
public class YuiBasicAnimateJSEditPart extends EditPartWithListener {
	private LetsAjaxDirectEditManager directManager = null;

	/**
	 * 属性に変更があったとき通知するメソッド
	 * 
	 * @see jp.co.cybec.laxide.editParts.EditPartWithListener#propertyChange(java.beans.PropertyChangeEvent)
	 */
	public void propertyChange(PropertyChangeEvent evt) {
		// 変更の型がモデルの位置情報の変更を示すものかどうか
		if (evt.getPropertyName().equals(YuiBasicAnimateModel.P_CONSTRAINT)) {
			refreshVisuals(); // ビューを更新する
		} else if (evt.getPropertyName().equals(
				YuiBasicAnimateModel.P_TARGET_ID)) {
			// モデルのテキストが変更されたのでビューに表示するテキストを更新
			Label label = (Label) getFigure();
			((Label) label.getChildren().get(1)).setText((String) evt
					.getNewValue());
		}
	}

	/**
	 * YahooUIを生成するクラス
	 * 
	 * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
	 */
	protected IFigure createFigure() {
		YuiBasicAnimateModel model = (YuiBasicAnimateModel) getModel();
		Label typeLabel = new Label();
		typeLabel.setText(model.getType());
		typeLabel.setOpaque(true);
		typeLabel.setSize(80, 30);
		typeLabel.setBorder(new CompoundBorder(new LineBorder(),
				new MarginBorder(3)));

		Label label = new Label();
		label.setText(model.getTargetId());
		label.setOpaque(true);
		label.setSize(80, 30);
		label.setBorder(new CompoundBorder(new LineBorder(),
				new MarginBorder(3)));

		// 外枠とマージンの設定
		Label parentLabel = new Label();
		parentLabel.setBorder(new CompoundBorder(new LineBorder(),
				new MarginBorder(3)));
		parentLabel.setLayoutManager(new ToolbarLayout());
		parentLabel.setBackgroundColor(ColorConstants.orange);
		// 背景色を不透明に
		parentLabel.setOpaque(true);
		parentLabel.setSize(80, 80);
		parentLabel.add(typeLabel);
		parentLabel.add(label);

		return parentLabel;
	}

	protected void refreshVisuals() {
		// 制約の取得
		Rectangle constraint = ((YuiBasicAnimateModel) getModel())
				.getConstraint();

		// Rectangleオブジェクトを制約としてビューに設定する
		// setLayoutConstraintメソッドは親EditPartから呼び出す
		((GraphicalEditPart) getParent()).setLayoutConstraint(this,
				getFigure(), constraint);
	}

	protected void createEditPolicies() {
		// エディットポリシーを作成してインストール
		installEditPolicy(EditPolicy.COMPONENT_ROLE,
				new LetsAjaxComponentEditPolicy());
		installEditPolicy(EditPolicy.DIRECT_EDIT_ROLE,
				new LetsAjaxDirectEditPolicy());
	}

	public void performRequest(Request req) {
		// Requestがモデル・プロパティの直接編集を要求するものかどうか
		if (req.getType().equals(RequestConstants.REQ_DIRECT_EDIT)) {
			performDirectEdit();
			return;
		}
		super.performRequest(req);
	}

	private void performDirectEdit() {
		if (directManager == null) {
			directManager = new LetsAjaxDirectEditManager(this,
					TextCellEditor.class, new LetsAjaxCellEditorLocator(
							getFigure()));
		}
		directManager.show(); // セル・エディタの表示
	}

}
